/*******************************************************************************
+
+  LEDA  2.2.0                                                 03-05-1992
+
+
+  sweep_segments.h
+
+
+  Copyright (c) 1992  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 6600 Saarbruecken, FRG     
+  All rights reserved.
+ 
*******************************************************************************/


#ifndef SWEEPSEGMENTSH
#define SWEEPSEGMENTSH

#include <LEDA/segment.h>
#include <LEDA/graph.h>

declare2(GRAPH,point,int)


//------------------------------------------------------------------------------
// line sweep for straight line segments
//------------------------------------------------------------------------------

void SWEEP_SEGMENTS(const list(segment)&, const list(segment)&, 
                                          GRAPH(point,int)&);

void SWEEP_SEGMENTS(const list(segment)&, list(point)&);


inline void SEGMENT_INTERSECTION(const list(segment)& L, list(point)& P)
{ SWEEP_SEGMENTS(L,P); }

#endif
